//
//      Sciencéthic
//
//      Télémètre à Ultrasons
//

#define BrocheConnexion 7 // Définit la broche de connexion du module émetteur-récepteur ultrasons
                          // Ici ce dernier doit être connecté sur la broche D7
                          // Vous pouvez changer ce nombre par exemple 2 pour connecté le module
                          // sur la broche D2
 float N =100;            // déclare le nombre N de mesures qui seront effectuées

void setup()              // Initialisation du programme
{
    Serial.begin(9600);   // Initialise la vitesse de communication entre la carte Plug'Uino et le PC
                          // à 9600 bps
   
    }
void loop()               // Boucle principale
{
  float distance = 0.3;   // Valeur de la distance entre l'émetteur-récepteur et l'obstacle en mètre
  float duree = 0;  // initialise la variable duree à 0
  for(int i = 1; i<=N; i++) // démarre une boucle de N mesures
  {
    pinMode(BrocheConnexion, OUTPUT);     // Les lignes 25 à 28
    digitalWrite(BrocheConnexion, HIGH);  // génèrent une salve d'ultrasons
    delayMicroseconds(5);                 //
    digitalWrite(BrocheConnexion,LOW);    //
    pinMode(BrocheConnexion,INPUT);       //
    duree = duree + pulseIn(BrocheConnexion,HIGH); // mesure la durée d'aller-retour de la salve et 
                                                   // l'ajoute aux mesures précédentes
    delay(200);                            // Attend 200 ms avant de renvoyer une salve (évite les échos parasites)
  }                                              
  float dureemoyenne = duree*1e-6/N ;         // calcule la durée moyenne d'aller-retour, convertie en s
  float vitesse = distance*2/dureemoyenne ;   // Calcule la vitesse qui correspond au rapport de la
                                              // distance parcourue par l'onde (soit le double de la distance
                                              // entre le module émetteur-récepteur et l'obstacle)
                                              // par la durée moyenne d'aller-retour
  Serial.print("La vitesse moyenne est de "); // Affiche la phrase entre guillements
  Serial.print(vitesse);                      // Affiche la vitesse
  Serial.println(" m/s");                     // Affiche l'unité, et passe à la ligne
  delay(250);                                 // Attend 250 ms avant de recommencer
}
